# TapyrusApiClient::AddressApi

All URIs are relative to *https://ap-01.tapyrus.chaintope.com/api/v1*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**create_address**](AddressApi.md#create_address) | **POST** /addresses | アドレスを生成して返します。 |
| [**get_addresses**](AddressApi.md#get_addresses) | **GET** /addresses | これまで生成したアドレスを一覧にして返します。 |


## create_address

> String create_address

アドレスを生成して返します。

受金用のアドレス生成して返します。

### Examples

```ruby
require 'time'
require 'tapyrus-api-client'
# setup authorization
TapyrusApiClient.configure do |config|end

api_instance = TapyrusApiClient::AddressApi.new

begin
  # アドレスを生成して返します。
  result = api_instance.create_address
  p result
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling AddressApi->create_address: #{e}"
end
```

#### Using the create_address_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(String, Integer, Hash)> create_address_with_http_info

```ruby
begin
  # アドレスを生成して返します。
  data, status_code, headers = api_instance.create_address_with_http_info
  p status_code # => 2xx
  p headers # => { ... }
  p data # => String
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling AddressApi->create_address_with_http_info: #{e}"
end
```

### Parameters

This endpoint does not need any parameter.

### Return type

**String**

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## get_addresses

> <GetAddressesResponse> get_addresses(opts)

これまで生成したアドレスを一覧にして返します。

これまで生成したアドレスを一覧にして返します。

### Examples

```ruby
require 'time'
require 'tapyrus-api-client'
# setup authorization
TapyrusApiClient.configure do |config|end

api_instance = TapyrusApiClient::AddressApi.new
opts = {
  per: 56, # Integer | 1ページあたりの件数
  page: 56 # Integer | ページ番号
}

begin
  # これまで生成したアドレスを一覧にして返します。
  result = api_instance.get_addresses(opts)
  p result
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling AddressApi->get_addresses: #{e}"
end
```

#### Using the get_addresses_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<GetAddressesResponse>, Integer, Hash)> get_addresses_with_http_info(opts)

```ruby
begin
  # これまで生成したアドレスを一覧にして返します。
  data, status_code, headers = api_instance.get_addresses_with_http_info(opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <GetAddressesResponse>
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling AddressApi->get_addresses_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **per** | **Integer** | 1ページあたりの件数 | [optional] |
| **page** | **Integer** | ページ番号 | [optional] |

### Return type

[**GetAddressesResponse**](GetAddressesResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

