# TapyrusApiClient::CreateUserRequest

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **id_token** | **String** | [Token Endpoint](http://openid-foundation-japan.github.io/openid-connect-core-1_0.ja.html#TokenEndpoint) の応答に含まれる id_token |  |
| **issuer** | **String** | [OpenID Provider Metadata](https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata) における issuer |  |
| **client_id** | **String** | [OAuth 2.0 Client Credential](https://datatracker.ietf.org/doc/html/rfc6749#section-2.3.1) における client_id |  |
| **access_token** | **String** | [Token Endpoint](http://openid-foundation-japan.github.io/openid-connect-core-1_0.ja.html#TokenEndpoint) の応答に含まれる access_token |  |

## Example

```ruby
require 'tapyrus-api-client'

instance = TapyrusApiClient::CreateUserRequest.new(
  id_token: eyJhbGciOiJSUzI1NiIsImtpZCI6IjFlOWdkazcifQ.ewogImlzcyI6ICJodHRwOi8vc2VydmVyLmV4YW1wbGUuY29tIiwKICJzdWIiOiAiMjQ4Mjg5NzYxMDAxIiwKICJhdWQiOiAiczZCaGRSa3F0MyIsCiAibm9uY2UiOiAibi0wUzZfV3pBMk1qIiwKICJleHAiOiAxMzExMjgxOTcwLAogImlhdCI6IDEzMTEyODA5NzAKfQ.ggW8hZ1EuVLuxNuuIJKX_V8a_OMXzR0EHR9R6jgdqrOOF4daGU96Sr_P6qJp6IcmD3HP99Obi1PRs-cwh3LO-p146waJ8IhehcwL7F09JdijmBqkvPeB2T9CJNqeGpe-gccMg4vfKjkM8FcGvnzZUN4_KSP0aAp1tOJ1zZwgjxqGByKHiOtX7TpdQyHE5lcMiKPXfEIQILVq0pc_E2DzL7emopWoaoZTF_m0_N0YzFC6g6EJbOEoRoSK5hoDalrcvRYLSrQAZZKflyuVCyixEoV9GfNQC3_osjzw2PAithfubEEBLuVVk4XUVrWOLrLl0nx7RkKU8NXNHq-rvKMzqg,
  issuer: https://server.example.com,
  client_id: s6BhdRkqt3,
  access_token: SlAV32hkKG
)
```

