# TapyrusApiClient::PaymentApi

All URIs are relative to *https://ap-01.tapyrus.chaintope.com/api/v1*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**transfer**](PaymentApi.md#transfer) | **POST** /payment | 資金の送金 |


## transfer

> <PaymentResponse> transfer(opts)

資金の送金

指定したアドレスに任意のtapyrusを送金します。

### Examples

```ruby
require 'time'
require 'tapyrus-api-client'
# setup authorization
TapyrusApiClient.configure do |config|end

api_instance = TapyrusApiClient::PaymentApi.new
opts = {
  payment_request: TapyrusApiClient::PaymentRequest.new({address: '1CY6TSSARn8rAFD9chCghX5B7j4PKR8S1a', amount: 10000000}) # PaymentRequest | `address`, `amount`を受け取り、アドレスに対して指定した額の資金(tapyrus)を送金します。 任意で`fee`を設定し、送金手数料を指定できます。 
}

begin
  # 資金の送金
  result = api_instance.transfer(opts)
  p result
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling PaymentApi->transfer: #{e}"
end
```

#### Using the transfer_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<PaymentResponse>, Integer, Hash)> transfer_with_http_info(opts)

```ruby
begin
  # 資金の送金
  data, status_code, headers = api_instance.transfer_with_http_info(opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <PaymentResponse>
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling PaymentApi->transfer_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **payment_request** | [**PaymentRequest**](PaymentRequest.md) | &#x60;address&#x60;, &#x60;amount&#x60;を受け取り、アドレスに対して指定した額の資金(tapyrus)を送金します。 任意で&#x60;fee&#x60;を設定し、送金手数料を指定できます。  | [optional] |

### Return type

[**PaymentResponse**](PaymentResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

