# TapyrusApiClient::TimestampApi

All URIs are relative to *https://ap-01.tapyrus.chaintope.com/api/v1*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**add_timestamp**](TimestampApi.md#add_timestamp) | **POST** /timestamp | Timestampを記録 |
| [**get_timestamps**](TimestampApi.md#get_timestamps) | **GET** /timestamps | Timestamp一覧表示 |


## add_timestamp

> add_timestamp(opts)

Timestampを記録

ブロックチェーンにハッシュ値をタイムスタンプとして記録します。

### Examples

```ruby
require 'time'
require 'tapyrus-api-client'
# setup authorization
TapyrusApiClient.configure do |config|end

api_instance = TapyrusApiClient::TimestampApi.new
opts = {
  add_timestamp_request: TapyrusApiClient::AddTimestampRequest.new({content_hash: '9ccc644b03a88358a754962903a659a2d338767ee61674dde5434702a6256e6d'}) # AddTimestampRequest | `content_hash`, `prefix`を受け取り、ブロックチェーンにハッシュ値をタイムスタンプとして記録します。
}

begin
  # Timestampを記録
  api_instance.add_timestamp(opts)
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling TimestampApi->add_timestamp: #{e}"
end
```

#### Using the add_timestamp_with_http_info variant

This returns an Array which contains the response data (`nil` in this case), status code and headers.

> <Array(nil, Integer, Hash)> add_timestamp_with_http_info(opts)

```ruby
begin
  # Timestampを記録
  data, status_code, headers = api_instance.add_timestamp_with_http_info(opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => nil
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling TimestampApi->add_timestamp_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **add_timestamp_request** | [**AddTimestampRequest**](AddTimestampRequest.md) | &#x60;content_hash&#x60;, &#x60;prefix&#x60;を受け取り、ブロックチェーンにハッシュ値をタイムスタンプとして記録します。 | [optional] |

### Return type

nil (empty response body)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: Not defined


## get_timestamps

> Array&lt;Array&gt; get_timestamps

Timestamp一覧表示

ブロックチェーンに記録したタイムスタンプを取得し、`content_hash`,`prefix`,`txid`を一覧で表示します。

### Examples

```ruby
require 'time'
require 'tapyrus-api-client'
# setup authorization
TapyrusApiClient.configure do |config|end

api_instance = TapyrusApiClient::TimestampApi.new

begin
  # Timestamp一覧表示
  result = api_instance.get_timestamps
  p result
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling TimestampApi->get_timestamps: #{e}"
end
```

#### Using the get_timestamps_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(Array&lt;Array&gt;, Integer, Hash)> get_timestamps_with_http_info

```ruby
begin
  # Timestamp一覧表示
  data, status_code, headers = api_instance.get_timestamps_with_http_info
  p status_code # => 2xx
  p headers # => { ... }
  p data # => Array&lt;Array&gt;
rescue TapyrusApiClient::ApiError => e
  puts "Error when calling TimestampApi->get_timestamps_with_http_info: #{e}"
end
```

### Parameters

This endpoint does not need any parameter.

### Return type

**Array&lt;Array&gt;**

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

